program wingman;

uses dos,crt,objects;

{}
{ Int 14 Request consts}
{ They go in the various Int 14h Request Structure Parameters,}
{   or are sent as return values (error codes & such).}
{}

{--------------------------------------------------------------------------}
{ INT 14h USB Functions}
{--------------------------------------------------------------------------}
const I14BXInput        =$5553 ;{'US'}
const I14CXInput        =$4221 ;{'B!'}

const I14AXInstallCheck =$5000 ;{Installation Check Function}
const I14AXDoFunction   =$5001 ;{All other functions}


{//--------------------------------------------------------------------------
//Int 14h Request Types
//--------------------------------------------------------------------------}
const   I14RRTHostClass       =$00 ;{Host/System/OS Class}
const   I14RRTGetHostSWInfo   =$01 ;{Get Host Software Info}
const   I14RRTGetHostHWInfo   =$02 ;{Get Host Hardware Info}
const   I14RRTGetHostVendInfo =$03 ;{Get Host Vendor Info}
const   I14RRTGetHostStatus   =$04 ;{Get Current Host Status}
const   I14RRTHostRun         =$08 ;{Start/Run/Resume Host}
const   I14RRTHostStop        =$09 ;{Stop Host}
const   I14RRTHostReset       =$0A ;{Reset Host}
const   I14RRTHostSuspend     =$0B ;{Global Suspend Host}
const   I14RRTHostResume      =$0C ;{Force Global Resume on Host}
const I14RRTTimingClass       =$10 ;{Frame Timing Class}
const   I14RRTRegTmgOwner     =$11 ;{Register as Timing Owner}
const   I14RRTUnRegTmgOwner   =$12 ;{UnRegister as Timing Owner}
const   I14RRTIncTiming       =$13 ;{Increment (Slow Down) Frame Timing}
const   I14RRTDecTiming       =$14 ;{Decrement (Speed Up) Frame Timing}
const   I14RRTChangeTiming    =$15 ;{Change Frame Timing (by Large Amount)}
const I14RRTHubClass          =$20 ;{Hub Class}
const   I14RRTGetDvcHubInfo   =$21 ;{Get Hub Info for Device}
const   I14RRTNewDvcConn      =$24 ;{Hub has Detected new Device}
const   I14RRTDvcDisc         =$25 ;{Device has been Disconnected}
const   I14RRTSendHubChar     =$27 ;{Send Hub Characteristics to Host}
const   I14RRTEnableHubPort   =$28 ;{Enable Device given Hub & Port}
const   I14RRTDisableHubPort  =$29 ;{Disable Device given Hub & Port}
const   I14RRTResetHubPort    =$2A ;{Reset Device given Hub & Port}
const   I14RRTSuspendHubPort  =$2B ;{Suspend Device given Hub & Port}
const   I14RRTResumeHubPort   =$2C ;{Resume Device given Hub & Port}
const   I14RRTPwrOnHubPort    =$2D ;{Power On Device given Hub & Port}
const   I14RRTPwrOffHubPort   =$2E ;{Power Off Device given Hub & Port}
const   I14RRTPwrResetHubPort =$2F ;{Power Reset Device given Hub & Port}
const I14RRTTPowerClass       =$30 ;{Power Class}
const   I14RRTGetDvcPowerInfo =$31 ;{Get Power Info for Device}
const   I14RRTPwrOnDevice     =$3D ;{Power On Device given Dvc Addr}
const   I14RRTPwrOffDevice    =$3E ;{Power Off Device given Dvc Addr}
const   I14RRTPwrResetDevice  =$3F ;{Power Reset Device given Dvc Addr}
const I14RRTDeviceClass       =$40 ;{Device Class}
const   I14RRTGetDvcClassInfo =$41 ;{Get Device Class Info}
const   I14RRTGetDvcVendInfo  =$42 ;{Get Device Vendor Info}
const   I14RRTGetDvcStatus    =$43 ;{Get Device Status}
const   I14RRTEnableDevice    =$48 ;{Enable/Resume Device given Dvc Addr}
const   I14RRTDisableDevice   =$49 ;{Disable Device given Dvc Addr}
const   I14RRTResetDevice     =$4A ;{Reset Device given Dvc Addr}
const   I14RRTSuspendDevice   =$4B ;{Suspend Device given Dvc Addr}
const   I14RRTResumeDevice    =$4C ;{Resume Device given Dvc Addr}
const I14RRTConfigClass       =$50 ;{Configuration Class}
const I14RRTConfigingIntf     =$51 ;{;Interface is Being Configured}
const I14RRTConfigIntfDone    =$52 ;{Interface Configuration is Done}

const   I14RRTSetNewConfig    =$58 ;{Set/Change Device Config Value}
const I14RRTInterfaceClass    =$60 ;{Interface Class}
const   I14RRTFindRegIntf     =$62 ;{Look for Registered Interface}
const   I14RRTFindUnRegIntf   =$63 ;{Look for Unregistered Interface}
const   I14RRTRegIntfOwner    =$64 ;{Register as Interface Owner}
const   I14RRTUnRegIntfOwner  =$65 ;{Unregister as Interface Owner}
const   I14RRTIntfDontLook    =$68 ;{Existing Interface Owner Don't Look}
const I14RRTAltIntfClass      =$70 ;{Alternate Interface Class}
const   I14RRTGetAltIntfInfo  =$71 ;{Get Alternate Interface Info}
const I14RRTEndPointClass     =$80 ;{End Point Class}
const I14RRTPacketClass       =$90 ;{Packet Class}
const   I14RRTDoIsoch         =$94 ;{Schedule Isochronous Transaction}
const   I14RRTDoInterruptPer  =$95 ;{Schedule Periodic Interrupt}
const   I14RRTDoControl       =$96 ;{Schedule Control/Setup Request}
const   I14RRTDoBulk          =$97 ;{Schedule Bulk Transaction}
const   I14RRTDoInterrupt1T   =$98 ;{Schedule One-Time Interrupt}
const   I14RRTCloseHandle     =$9C ;{Close/Remove Scheduled Transaction}
const   I14RRTChangeIntPer    =$9D ;{Change Periodicity of Interrupt}
const   I14RRTGetTransStatus  =$9F ;{Get Status of Packet Transaction}
const I14RRTMiscClass         =$A0 ;{Miscellaneous Class}
const   I14RRTLargeCallDone   =$A1 ;{Large (Complicated) Call Complete}
const   I14RRTBeepSpeaker     =$AF ;{Beep the Speaker}
const I14RRTInterHostClass    =$E0 ;{Inter-Host Communication Class}
const   I14RRTCopyNDTable     =$E5 ;{Copy New Device Ownership Table}
const I14RRTInternalClass     =$F0 ;{Host Internal/Troubleshooting Class}



{--------------------------------------------------------------------------}
{Int 14h Flags}
{--------------------------------------------------------------------------}
const I14RFlagIn            =$01 ;{In Direction}
const I14RFlagLowSpeed      =$02 ;{Low-Speed Device}
const I14RFlagHiSpeed       =$04 ;{High-Speed Device}
const I14RFlagNoRetries     =$10 ;{No Auto Retries for Control}
const I14RFlagShortPktOK    =$20 ;{No Retries for Short Packets}
const I14RFlagSpecificFrame =$40 ;{Use Specific Frame Number}
const I14RFlagAddrIsPhys    =$80 ;{Data Address is Physical}

{--------------------------------------------------------------------------}
{Error Codes Returned on Completion of Transfer Descriptor (AX)}
{--------------------------------------------------------------------------}
const TDStsOK             =$0000 ;{ACK Received (TD completed OK / no errors)}
const TDStsNAKReceived    =$0001 ;{NAK Received}
const TDStsStalled        =$0002 ;{TD is Stalled}
const TDStsTimeout        =$0004 ;{TD has timed out (Bulk/Control)}
const TDStsOverDue        =$0008 ;{TD is OverDue (Int/Isoch)}
const TDStsShortPacket    =$0010 ;{TD Short Packet Detected (w/ SPD Enabled)}
const TDStsBabbleDetected =$0020 ;{Babble Detected}
const TDStsCRCTOReceived  =$0040 ;{CRC/TimeOut Error Received}
const TDStsBitStuffError  =$0080 ;{Rx Data contained > 6 ones in a row}
const TDStsDataBuffErr    =$0100 ;{Data Buffer Error}
const TDStsControlSetup   =$1000 ;{Error occurred during Control Setup Stage}
const TDStsLargeCallErr   =$8000 ;{Error during Large Call}



Type
PInt14RequestStruc = ^Int14RequestStruc;
Int14RequestStruc  = Record
I14RRequestType:byte;     {//Request Type}
I14RFlags:byte;           {//Bit-level Flags}
I14RHostIndex:byte;       {//Host Index}
I14RDeviceAddress:byte;   {//USB Device Address}
                          {//  Also I14RHubAddress}
I14REndPoint:byte;        {//End Point}
                                     {//  Also I14RHubPort}
                                     {//  Also I14RAltInterface}
I14RConfigValue:byte;     {//Configuration Value}
                                     {//  Also I14RCloseID}
I14RInterfaceNum:byte;    {//Interface Number}
I14RSearchIndex:byte;     {//Search Index}
I14RVendorID:word;        {//Vendor ID}
I14RProductID:word;       {//Product ID}
I14RDvcClass:byte;        {//Device Class}
I14RDvcSubClass:byte;     {//Device SubClass}
I14RDvcProtocol:byte;     {//Device Protocol}
I14RIntfClass:byte;       {//Interface Class}
I14RIntfSubClass:byte;    {//Interface SubClass}
I14RIntfProtocol:byte;    {//Interface Protocol}
I14RRequestHandle:word;   {//Request Handle Number}
I14RPeriodicity:word;     {//Interrupt Periodicity/Duration}
                                     {//  Also I14RBeepFrequency}
I14RTimeout:word;         {//Transaction Timeout Value}
I14RDataAddrOff:word;     {//Data Address Offset}
I14RDataAddrSeg:word;     {//Data Address Segment}
I14RDataSize:word;        {//Size of Data (bytes)}

I14RCallBackAddrOff:word; {//Call Back Address Offset (IP)}
                                     {//  Also I14RLargeCallRtnCode}
I14RCallBackAddrSeg:word; {//Call Back Address Segment (CS)}

I14RUserPktID:word;       {//User Packet ID}
{start of 8 byte setup packet}
I14RSetupReqType:byte;    {//Setup Packet Request Type}
I14RSetupReq:byte;        {//Setup Packet Request Code}
I14RSetupValue:word;      {//Setup Packet Value}
I14RSetupIndex:word;      {//Setup Packet Index}
I14RSetupLength:word;     {//Setup Packet Length}
{end of packet}
I14RFrameTiming:word;     {//Frame Timing Value (def = 12000)}
                                    { //  Also I14RFrameIndex}
I14RIsochSchedOff:word;   {//Isochronous Schedule Table Offset}
I14RIsochSchedSeg:word;   {//Isochronous Schedule Table Segment}
I14RFiller1:word;         {//Fillers to equal 64 bytes}
I14RFiller2:word;
I14RFiller3:word;
I14RFiller4:word;
I14RFiller5:word;
I14RFiller6:word;
I14RFiller7:word;
end;

 {
  ;----------------------------------------------------------------------------
  ;Format of data returned by a Get Device Descriptor
  ;----------------------------------------------------------------------------
}
Type  DeviceDescriptor   = Record    {Structure for a Device Descriptor}
    DDLength            :byte   ;{Size of Descriptor in bytes}
    DDDescrType         :byte ;{DescrTypeDevice}
    DDUSBRelease        :word  ;{USB Compliance  bcd (0210h=v2.10)}
    DDDvcClass          :byte   ;{Device Class (defined by USB-IF)}
    DDDvcSubClass      :byte   ;{Device SubClass (defined by USB-IF)}
    DDDvcProtocol       :byte   ;{Device Protocol (defined by USB-IF)}
    DDMaxPktSize        :byte   ;{Max Packet Size for EndPoint 0}
                              {  MUST be 8, 16, 32, or 64}
    DDVendorID          :word   ;{Vendor ID (defined by USB-IF)}
    DDProductID         :word   ;{Product ID (defined by manufacturer)}
    DDDeviceRelease     :word   ;{Device Release Number (bcd)}
    DDManufacturerIndx  :byte   ;{Index of Manufacturer String}
    DDProductIndx       :byte   ;{Index of Product String}
    DDSerialNumberIndx  :byte   ;{Index of Serial Number String}
    DDNumConfigs        :byte   ;{Number of possible Configurations}
   END;
const  DeviceDescriptorSize = sizeof (DeviceDescriptor);

var b64:  Int14RequestStruc;
var dd:  DeviceDescriptor;
var regs:registers;

procedure int; begin
     Regs.DS:=seg(b64);   {pointer}
     Regs.DX:=ofs(b64);    {size}
     Regs.AX:= I14AXDoFunction;    {Set Function}
     Regs.BX:= I14BXInput;    {"US"}
     Regs.CX:= I14CXInput;    {"B!"}
Intr($14,Regs);
end;

begin
b64.I14RRequestType:=I14RRTDoControl;
b64.I14RHostIndex := 0;
b64.I14RFlags:=0;
b64.I14RDeviceAddress:=2;{Address of Device being configured (2-127)}
b64.I14REndPoint:=0;
b64.I14RTimeout:=5;
b64.I14RDataAddrOff:=ofs(dd);
b64.I14RDataAddrSeg:=seg(dd);
b64.I14RDataSize:=18;
b64.I14RCallBackAddrOff:=0;{Large Return Address (CS:IP)}    {word}
b64.I14RCallBackAddrSeg:=0;{}    {word}
b64.I14RUserPktID:=123;{Value to return in BX on Large Return}{word}
b64.I14RSetupReqType:=$80;{byte}
b64.I14RSetupReq:=6;{byte}
b64.I14RSetupValue:=$100;{word}
b64.I14RSetupIndex:=0;{word}
b64.I14RSetupLength:=18;{word}

{clear DD}
with DD do begin
ddlength:=0;
dddescrtype:=0;
ddusbrelease:=0;
dddvcclass:=0;
dddvcsubclass:=0;
dddvcprotocol:=0;
ddmaxpktsize:=0;
ddvendorid:=0;
end;
int;
writeln('');
writeln('int 14:');
writeln('ax:');
writeln(regs.ax);
delay(64000);
delay(64000);
delay(64000);
delay(64000);
delay(64000);
delay(64000);

{did anything happen to dd?}
writeln('DD:');
with DD do begin
writeln(ddlength);
writeln(DDDescrType);
writeln(DDUSBRelease);
writeln(DDDvcClass);
writeln(DDDvcSubClass);
writeln(DDDvcProtocol);
writeln(DDMaxPktSize);
writeln(DDVendorID);
end;

writeln('');
delay(64000);
delay(64000);
delay(64000);
end.
